
#ifndef LEVDYN_H
#define LEVDYN_H

#include "levdata.h"
#include "lib/fixed.h"
#include "texture.h"
#include "prothing.h"

#define LD_DYNDECL(type) void type##_dyninit(void *_dyn,const void *_lump,LevData *ld) 
#define LD_DYNINIT(type,dyn,lump) type##Dyn *dyn=_dyn;const type##Data *lump=_lump

typedef struct {
   fixed x,y,tx,ty,proj,_spare;
} VertexDyn;
LD_DYNDECL(Vertex);

typedef struct {
   Texture *utex,*mtex,*ltex,*_spare1;
   short uanim,manim,lanim;
   short _spare2;
} SideDyn;
LD_DYNDECL(Side);

typedef struct {
   fixed length;
} LineDyn;
LD_DYNDECL(Line);

/*
typedef enum  {
   SM_IDLE,
   
   SM_MOVINGCEILING,
   SM_OPENDOOR,SM_CLOSEDOOR,
   SM_OPENDOOR_FAST,SM_CLOSEDOOR_FAST,
   
   SM_MOVINGFLOOR=0x1000,
   SM_LIFT
} SectorMoveState;
*/

#define SM_MOVING_CEILING(sm) ((sm)>SM_MOVINGCEILING&&(sm)<SM_MOVINGFLOOR)
#define SM_MOVING_FLOOR(sm) ((sm)>SM_MOVINGFLOOR)

typedef struct {
   fixed floor,ceiling;
   Texture *ftex,*ctex;
   short fanim,canim;
   fixed dark; /* 0 is infinite light (see forever), 1 is very dark */
   int sky,_spare; /* sky: bit 1 is ceiling, bit 2 floor */
} SectorDyn;
LD_DYNDECL(Sector);

#define MAX_SPARE_THINGS 16
typedef struct {
   fixed x,y,z;
   fixed angle,elev;
   fixed dx,dy,dz,dangle;
   ThingSignal pending_signal;
   const ProtoThing *proto;
   const ThingPhase *phase_tbl;
   short phase,phase_wait;
   Texture *image;
   int hits,armour;
   short mirror_image;
   short sector;
   short target;
   short owner;
} ThingDyn;
LD_DYNDECL(Thing);

#define ldvertexd(ld) ((VertexDyn *)(ld->dyn[ML_VERTEX]))
#define ldsectord(ld) ((SectorDyn *)(ld->dyn[ML_SECTOR]))
#define ldlined(ld) ((LineDyn *)(ld->dyn[ML_LINE]))
#define ldsided(ld) ((SideDyn *)(ld->dyn[ML_SIDE]))
#define ldthingd(ld) ((ThingDyn *)(ld->dyn[ML_THING]))

#define ldthingph(ld,on) (ldthingd(ld)[on].phase_tbl+ldthingd(ld)[on].phase)

#define wall_length(ld,ln) (ldlined(ld)[ln].length)

#endif











