#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <vgakeyboard.h>

#include "lib/log.h"
#include "input.h"

void get_input(PlayerInput *in) {
   int speed=UNIT_SPEED;
   keyboard_update();
   memset(in,0,sizeof(PlayerInput));
   /* shift */
   if(keyboard_keypressed(42)||keyboard_keypressed(54)) speed=2*UNIT_SPEED;
   /* movement */
   if(keyboard_keypressed(100)||keyboard_keypressed(56)) {
      if(keyboard_keypressed(SCANCODE_CURSORLEFT)||keyboard_keypressed(SCANCODE_CURSORBLOCKLEFT)) 
	in->sideways+=speed;
      if(keyboard_keypressed(SCANCODE_CURSORRIGHT)||keyboard_keypressed(SCANCODE_CURSORBLOCKRIGHT)) 
	in->sideways-=speed;
   }
   else {
      if(keyboard_keypressed(SCANCODE_CURSORLEFT)||keyboard_keypressed(SCANCODE_CURSORBLOCKLEFT)) 
	in->rotate+=speed;
      if(keyboard_keypressed(SCANCODE_CURSORRIGHT)||keyboard_keypressed(SCANCODE_CURSORBLOCKRIGHT)) 
	in->rotate-=speed;
   };
   if(keyboard_keypressed(SCANCODE_KEYPAD9)||keyboard_keypressed(SCANCODE_PAGEUP)) 
     in->lookup+=UNIT_SPEED;
   if(keyboard_keypressed(SCANCODE_KEYPAD3)||keyboard_keypressed(SCANCODE_PAGEDOWN)) 
     in->lookup-=UNIT_SPEED;
   
   if(keyboard_keypressed(SCANCODE_CURSORUP)||keyboard_keypressed(SCANCODE_CURSORBLOCKUP)) 
     in->forward+=speed;
   if(keyboard_keypressed(SCANCODE_CURSORDOWN)||keyboard_keypressed(SCANCODE_CURSORBLOCKDOWN)) 
     in->forward-=speed;
   /* bang bang */
   if(keyboard_keypressed(SCANCODE_TAB)) 
     in->w_sel=1;
   if(keyboard_keypressed(SCANCODE_ENTER)) 
     in->shoot=1;
   if(keyboard_keypressed(SCANCODE_SPACE)) 
     in->jump=UNIT_SPEED;
   if(keyboard_keypressed(SCANCODE_ESCAPE)) 
     in->quit=1;
#define NK(x) if(keyboard_keypressed(SCANCODE_##x)) in->select[x]=1
      NK(0);NK(1);NK(2);NK(3);NK(4);NK(5);NK(6);NK(7);NK(8);NK(9);
#undef NK   
};

void init_input(void) {
   if(keyboard_init())
     logprintf(LOG_FATAL,'I',"Console open failed");
   else
     logprintf(LOG_INFO,'I',"Console in raw mode");
};
void reset_input(void) {
   keyboard_close();
};

