
#ifndef SOUND_H
#define SOUND_H

#include "lib/fixed.h"

/* use 0 for these params to get defaults */
void init_sound(int speed);
void reset_sound(void);

void set_sound_volume(fixed vol);

typedef struct {
   fixed lfvol,rfvol,lbvol,rbvol;
   /* 
      what else could we add here? 
      different bend values for different channels?  Echo?
      we'd want to make sure that a generic sound module is
      available to implement complex stuff like that though
   */
} SoundBalance;

#define FLAT_BALANCE {FIXED_ONE,FIXED_ONE,FIXED_ONE,FIXED_ONE}

void play_sound(const unsigned char *sample,int len,
		SoundBalance balance,int myspeed);
void play_sound16(const signed short *sample,int len,
		  SoundBalance balance,int myspeed);

/* stop playing every sound now */
void purge_sound(void);

void poll_sound(void);

#endif
