#include <stdlib.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "xtexture.h"

#define scrn DefaultScreen(dpy)
#define rootw RootWindow(dpy,scrn)
#define visual DefaultVisual(dpy,scrn)

#define rotate(Pixel) \
   for(x=0;x<t->width;x++) { \
      Pixel *tx=t->texels; \
      tx+=(t->width-x-1)<<t->log2height; \
      for(y=t->height-1;y>=0;y--,tx++) \
	 XPutPixel(image,x,y,*tx==-1?0:*tx); \
   };
#define mirror(Pixel) \
   for(x=0;x<t->width;x++) { \
      Pixel *tx=t->texels; \
      tx+=x<<t->log2height; \
      for(y=t->height-1;y>=0;y--,tx++) \
	 XPutPixel(image,x,y,*tx==-1?0:*tx); \
   };

void xtexture(Display *dpy,Drawable d,Texture *t,int do_mirror) {
   int width,height;
   int frame_x,frame_y,depth,border;
   Window frame_root;
   int bypp;
   int x,y;
   int xo=0,yo=0;
   XImage *image;
   if(t==NULL) return;
   XGetGeometry(dpy,d,&frame_root,
		&frame_x,&frame_y,&width,&height,
		&border,&depth);
   if(width>t->width) xo=(width-t->width)/2;
   if(height>t->height) yo=(height-t->height)/2;
   if(do_mirror) do_mirror=1;
   bypp=depth/8;
   if(bypp==3) bypp++;
   if(t->xpix[do_mirror]==0) {
      load_texels(t,bypp);
      image=XCreateImage(dpy,
			 visual,
			 depth,
			 ZPixmap,0,malloc(bypp*t->height*t->width),
			 t->width,t->height,
			 8,bypp*t->width);
      if(do_mirror) switch(bypp) {
      case(1): mirror(signed char); break;
      case(2): mirror(signed short); break;
      case(4): mirror(signed int); break;
      } 
      else switch(bypp) {
      case(1): rotate(signed char); break;
      case(2): rotate(signed short); break;
      case(4): rotate(signed int); break;
      };
      t->xpix[do_mirror]=XCreatePixmap(dpy,d,t->width,t->height,depth);
      XPutImage(dpy,t->xpix[do_mirror]?t->xpix[do_mirror]:d,
		DefaultGC(dpy,scrn),image,0,0,
		t->xpix[do_mirror]?0:xo,t->xpix[do_mirror]?0:yo,
		t->width,t->height);
      XDestroyImage(image);
      if(t->xpix[do_mirror]) free_texels(t);
   };
   if(t->xpix[do_mirror])
      XCopyArea(dpy,t->xpix[do_mirror],d,DefaultGC(dpy,scrn),
		0,0,t->width,t->height,xo,yo);
};
